/**
 * Parses morphing expression
 * @param {string} morphing morphing textual representation
 * @returns morphing data object
 */
function _MORPH_RECOGNIZER(morphing) {

    const data = {
        in: `enliven-morph-${morphing}-in`,
        out: `enliven-morph-${morphing}-out`
    }
    
    const delayParser = (property) => {

        const key = `delay${property.split('-')[3].replace(/\b\w/g, l => l.toUpperCase())}`;
        let delay = _cssRule(`${property}`, 'animation-duration');
        if (delay.endsWith('s')) {
            delay = delay.substring(0, delay.length - 1);
            delay = `${delay.split('.')[1].replace('0', '')}00`;
        } else {
            delay = delay.substring(0, delay.length - 2);
        }
        data[key] = parseInt(delay);
    }

    try {
        delayParser(data.in);
        delayParser(data.out);
        return data;
    } catch (err) {
        console.error(`_MORPH_RECOGNIZER: unable to access css rule for ${morphing}`);
        return {};
    }
}