/**
 * Triggers icons morphing 
 * @param {object} settings 
 * -- next = next icon value (default: self)
 * -  morphing = animation name (default: 'huff')
 * 
 * @Feature (name=morph)
 */
function MorphTrick(settings) {

    settings = $.extend({
        morphing: 'huff'
    }, settings);

    let morphingData = _MORPH_RECOGNIZER(settings.morphing);
    if (!morphingData.delayIn || !morphingData.delayOut) {
        settings.morphing = 'huff';
        morphingData = _MORPH_RECOGNIZER(settings.morphing);
    }

    return this.each(function() {

        if ($(this).is(':animated')) return;

        const hasFollowing = settings.next;

        if (!hasFollowing) {
            settings.next = $(this).text().trim();
        }

        _trigger('morph', this, settings);

        if (!hasFollowing) {
            settings.next = null;
        }

        const $that = $(this);
        $that.addClass(morphingData.out);

        setTimeout(function() {

            $that.removeClass(morphingData.out);
            $that.html(settings.next);
            $that.addClass(morphingData.in);
            
            setTimeout(function() {

                $that.removeClass(morphingData.in);
            }, morphingData.delayIn);

        }, morphingData.delayOut);
    });
}